// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

// "main.cc"

// (c) OPAC Team, LIFL, 2002

/* This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
   
   Contact: cahon@lifl.fr
*/

#include <gtk/gtkmain.h>

#include "main_window.h"
#include "objectives.h"
#include "po_sets_list.h"
#include "logo_window.h"
#include "po_set.h"
#include "gnuplot.h"
#include "po_sets_contents.h"
#include "normal.h"
#include "progress_bar_window.h"
#include "load_problem.h"
#include "defaults.h"
#include "mess_window.h"

#include <config.h>
#include <unistd.h>

int main (int argc, char * argv []) {
	  
  // Gtk requires it :-) !
  gtk_init (& argc, & argv) ;
  
  // Logo window
  open_logo_window () ;
  
  // Main window
  open_main_window () ;

  open_PO_sets_list () ;
  
  PO_sets.reserve (100) ;
  
  reset_gnuplot () ;

  open_PO_sets_contents_window () ;    

  init_messages_window () ;
  open_messages_window () ;

  load_defaults () ;
  
  gtk_main () ;
 
  return 0 ;
}
