// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

// "pipe_process.h"

// (c) OPAC Team, LIFL, 2002

/* This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
   
   Contact: cahon@lifl.fr
*/

#ifndef pipe_process_h
#define pipe_process_h

#include <stdio.h>

class Pipe_Process {
  
public :
  
  // Constructors
  Pipe_Process (char * _filename, int _argc, char * _argv []) ;  
  Pipe_Process (char * _filename) ;
  
  // Sends the given string to standard input of the sub-process
  void send (const char * _buff, int _len) ;
  
private :
  
  FILE * file_write, * file_read ;
  
  int to_son [2], to_father [2], son_pid ;
} ;


#endif
