// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

// "po_set.h"

// (c) OPAC Team, LIFL, 2002

/* This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
   
   Contact: cahon@lifl.fr
*/

#ifndef po_set_h
#define po_set_h

#include <vector>
#include <string>
#include <iostream>

#include "mo_solution.h"

class POSet : public vector <MOSolution> {
  
public :
  
  // Constructors

  POSet () ;

  POSet (string _id,
	 string _file_name) ;
  
  bool operator > (const POSet & _pset) const ;
  /* Returns true if for each solution of '_pset', there is at least
     one another solution from the current set, that dominates that last one ...
   */
  
  /* Returns the string identifiant (in fact the filename embedding
     the solutions*/
  string & name () {
    
    return id ;
  }
  
  string & source () {
    
    return file_name ;
  }

  void update () ;

private :
  
  string id, file_name ; // String id. & source file name
  
  friend istream & operator >> (istream & _is, POSet & _pset) ;
} ;

// The global set of PO * sets ...
extern vector <POSet> PO_sets ;

istream & operator >> (istream & _is, POSet & _pset) ;

void load_telecom_files () ; 

#endif
